// HIGH motorPin1, left motor spins backwards
// HIGH motorPin2, left motor spins forwards
// HIGH motorPin3, right motor spins backwards
// HIGH motorPin4, right motor spins forwards

class motors {
  public:
    int _motorPin1, _motorPin2, _motorPin3, _motorPin4;
    motors (int motorPin1, int motorPin2, int motorPin3, int motorPin4);
    void setSpeed(int motorLeft, int motorRight);
};

motors::motors (int motorPin1, int motorPin2, int motorPin3, int motorPin4) {
  _motorPin1 = motorPin1;
  _motorPin2 = motorPin2;
  _motorPin3 = motorPin3;
  _motorPin4 = motorPin4;
  
  pinMode(_motorPin1, OUTPUT);
  pinMode(_motorPin2, OUTPUT);
  pinMode(_motorPin3, OUTPUT);
  pinMode(_motorPin4, OUTPUT);

  digitalWrite(_motorPin1, LOW);
  digitalWrite(_motorPin2, LOW);
  digitalWrite(_motorPin3, LOW);
  digitalWrite(_motorPin4, LOW);
}


void motors::setSpeed(int motorLeft, int motorRight) {
  if (motorLeft < 0 && motorRight < 0) { // both negative, both motors spin backwards, move robot backwards
    analogWrite(_motorPin1, abs(motorLeft));
    analogWrite(_motorPin3, abs(motorRight));
    digitalWrite(_motorPin2, LOW);
    digitalWrite(_motorPin4, LOW);
  }
  else if (motorLeft < 0 && motorRight > 0) { // left negative, right positive, spin robot counter clockwise
    analogWrite(_motorPin1, abs(motorLeft));
    analogWrite(_motorPin4, abs(motorRight));
    digitalWrite(_motorPin2, LOW);
    digitalWrite(_motorPin3, LOW);
  }
  else if (motorLeft > 0 && motorRight < 0) { // left positive, right negative, spin robot clockwise
    analogWrite(_motorPin2, abs(motorLeft));
    analogWrite(_motorPin3, abs(motorRight));
    digitalWrite(_motorPin1, LOW);
    digitalWrite(_motorPin4, LOW);
  }
  else if (motorLeft > 0 && motorRight > 0) { // left positive, right positive, move robot forwards
    analogWrite(_motorPin2, abs(motorLeft));
    analogWrite(_motorPin4, abs(motorRight));
    digitalWrite(_motorPin1, LOW);
    digitalWrite(_motorPin3, LOW);
  }
  else {
    digitalWrite(_motorPin1, LOW);
    digitalWrite(_motorPin2, LOW);
    digitalWrite(_motorPin3, LOW);
    digitalWrite(_motorPin4, LOW);
  }
}
